%% Mrselmlet 2. hzi feladat
%  Kirilly Mikls
%  CET61E

clear all;
close all;

N= 59;          % bzis elemszm
G = 1;          % bzisfggvny-vlaszts
p = 0.84;       % analizland egysg paramter
SNR = 40;       % jel-zaj szint

%% 1. feladat : bzis- s inverz bzis rendszer generlsa

w_arg = 2*pi/N;                                 % slytnyez szge
m = 0:1:(N-1);                                  % egysggykk sorszma
egyseg_gyokok = exp(j*w_arg*m);                 % egysggykk

n = 0:1:N-1;                                    % diszkrt id

% base_func sorai tartalmazzk a bzisvektorokat.
% Mivel a MATLAB indexelse 1-tl kezddik, a sorok sorszma 1-gyel nagyobb
% a bzisfggvny sorszmnl.
base_func = zeros(N,N);

% m=0 -nl DC komponenst kapunk
base_func(1,:) = ones(1,N);

for k = 1:1:(N-1)/2
    base_func(2*k, :) = real(egyseg_gyokok(k+1).^n);
    base_func(2*k+1, :) = imag(egyseg_gyokok(k+1).^n);
end

% inverz bzis
inv_base_func = zeros(N,N);

% dc komponens az inverz bzisban is van
inv_base_func(1,:) = ones(1,N);

for k = 1:1:(N-1)/2
    % 2-szeres szorzs, mert elvileg nem csak a x. bzisfggvnyt, hanem az
    % N-x.-et is fel kellene hasznlni a visszalltshoz
    inv_base_func(2*k, :) = 2*real(egyseg_gyokok(k+1).^-n);
    inv_base_func(2*k+1, :) = -2*imag(egyseg_gyokok(k+1).^-n);
end
% az inverz bzis sklzsa 1/N-nel
inv_base_func = inv_base_func /N;

clear n m k
%% 2. feladat : bzis- s inverz bzis rendszer ellenrzse

% skalr szorzsok elvgzse egy mtrixszorzsknt
scalar_products = inv_base_func * base_func';
% eltrs szmtsa az elvrttl
difference = scalar_products-eye(size(scalar_products));
% 1 ezrelk kerektsi pontatlansgot elfogadunk
if max(max(abs(difference))) > 0.001
    for y = 1:1:size(difference,1)
        for x = 1:1:size(difference,2)
            if abs(difference(y,x)) > 0.001
                'elteres itt: '
                helye = [x, y]
            end
        end
    end
    'Hiba : a nem inverzek!'
end

%% 5. feladat Bzissal ellltott jel s az analiztor mkdsnek 
%               demonstrcija

weights = randn(N, 1);  % 1 szrs 0 vrhat rtk, Gauss eloszls
y = generator(base_func, weights, N*2);
[y_hat, x_hat] = analysator(y, base_func, inv_base_func);
hibajel = [ y(1:end)-y_hat(1:end)];

figure(1)
    subplot(3,1,1); plot(y); title('y');
    subplot(3,1,2); plot(y_hat); title('y becsl');
    subplot(3,1,3); plot(hibajel); title('hibajel');

%% 6. feladat Hlzat analiztor

% A hlzat modellje
network_model_num = [0 (1-p^2) 0  ];
network_model_den = [1 0       p^2];
% szmtott karakterisztika
[h, w] = freqz(network_model_num, network_model_den, floor((N+1)/2));
% csak a Nyquist-frekvenciig rdekel minket, mivel vals egytthats
ampl = abs(h);
pha = phase(h);

% A gerjeszt jel minden frekvencin 0 kezdfzis, egysgnyi amplitdj
% koszinuszos jel, az analiztor kimenetn pedig a megfelel komponensek
% amplitdjt s fzistolst mrhetjk.
weights = ones(N,1);
weights(3:2:end) = 0;   % szinuszos tagok kinullzsa
x = generator(base_func, weights, 2*N);

y = filter(network_model_num, network_model_den, x); % a hlzat

[y_hat, x_hat] = analysator(y, base_func, inv_base_func);
h_hat = [x_hat(1,N);
    (x_hat(2:2:end,N)-j*x_hat(3:2:end,N))];

% eredmnyek kirajzolsa
figure (2)
    subplot (2,1,1)
    plot (0:2/N:1, ampl);
    hold on
    stem (0:2/N:1, abs(h_hat));
        title('amplitd menet');
        xlabel('normalizlt frekvencia');
        ylabel('amplitd');
        legend('szmtott', 'mrt');
    hold off
    subplot (2,1,2)
    plot (0:2/N:1, pha*180/pi);
    hold on
    stem (0:2/N:1, phase(h_hat)*180/pi);
        title('fzis menet');
        xlabel('normalizlt frekvencia');
        ylabel('fzis []');
        legend('szmtott', 'mrt');
    hold off
%% 7. feladat Additv bemeneti zaj hatsa
% generls s szrs ugyangy, mint elbb
weights = ones(N,1);
weights(3:2:end) = 0;   % szinuszos tagok kinullzsa
x = generator(base_func, weights, 5*N);
y = filter(network_model_num, network_model_den, x); % a hlzat
% megadott SNR belltsa
AGC = 1;
% AGC = 10^(SNR/20)/sqrt(var(y));
% y = y*AGC;

% additv egysgnyi amplitdj fehr zaj hozzadsa
n = randn(size(y));
y_noisy = y+n;

[y_hat, x_hat] = analysator(y_noisy, base_func, inv_base_func);

% eredmnyek kirajzolsa
figure (3)
    subplot (2,1,1)
    plot ((y_noisy-y_hat)/AGC)
    grid on
    title('Hibajel zaj kikszbls nlkl')
figure (4)
    subplot (2,1,1)
    semilogy (abs(y_noisy-y_hat)/AGC)
    grid on
    title('Hibajel zaj kikszbls nlkl - logaritmikus skln')    
% A modell N-periodikus jelek feldolgozsra kszlt.
% Wiener-szr felhasznlsval a rezontor bemenetn a nem periodikus
% jeleket ki lehet szrni. A megvalsts rekurzv.
gamma = 10^(-SNR/10);           % zaj/jel teljestmny lineris egysgben

egy_periodus = zeros (1,N);
y_filtered = zeros(size(y_noisy));
for i = 1:1:length(y_noisy)/N
    egy_periodus = egy_periodus + 1/(i + gamma)*(y_noisy( (i-1)*N+1 : i*N)-egy_periodus);
    y_filtered( (i-1)*N+1 : i*N) = egy_periodus;
end

[y_hat, x_hat] = analysator(y_filtered, base_func, inv_base_func);

% eredmnyek kirajzolsa
figure(3)
    subplot (2,1,2)
    plot ((y_filtered-y_hat)/AGC)
    grid on
    title('Hibajel zaj kikszbls hatsra')
figure(4)
    subplot (2,1,2)
    semilogy (abs(y_filtered-y_hat)/AGC)
    grid on
    title('Hibajel zaj kikszbls hatsra - logaritmikus skln')